
From: Stephen Rothwell <sfr@canb.auug.org.au>

This patch gathers all the struct flock64 definitions (and the operations),
puts them under !CONFIG_64BIT and cleans up the arch files.

Signed-off-by: Stephen Rothwell <sfr@canb.auug.org.au>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 include/asm-arm/fcntl.h     |   12 ------------
 include/asm-arm26/fcntl.h   |   12 ------------
 include/asm-cris/fcntl.h    |   17 -----------------
 include/asm-frv/fcntl.h     |   18 ------------------
 include/asm-generic/fcntl.h |   25 +++++++++++++++++++++++++
 include/asm-h8300/fcntl.h   |   12 ------------
 include/asm-i386/fcntl.h    |   17 -----------------
 include/asm-m32r/fcntl.h    |   17 -----------------
 include/asm-m68k/fcntl.h    |   12 ------------
 include/asm-mips/fcntl.h    |   12 +++---------
 include/asm-parisc/fcntl.h  |    8 --------
 include/asm-ppc/fcntl.h     |   14 --------------
 include/asm-s390/fcntl.h    |   26 --------------------------
 include/asm-sh/fcntl.h      |   18 ------------------
 include/asm-sh64/fcntl.h    |    6 ------
 include/asm-sparc/fcntl.h   |   14 +-------------
 include/asm-v850/fcntl.h    |   12 ------------
 include/asm-xtensa/fcntl.h  |    1 +
 18 files changed, 30 insertions(+), 223 deletions(-)

diff -puN include/asm-arm26/fcntl.h~clean-up-struct-flock64-definitions include/asm-arm26/fcntl.h
--- devel/include/asm-arm26/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-arm26/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -8,18 +8,6 @@
 #define O_DIRECT	0200000	/* direct disk access hint - currently ignored */
 #define O_LARGEFILE	0400000
 
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-
 #include <asm-generic/fcntl.h>
 
 #endif
diff -puN include/asm-arm/fcntl.h~clean-up-struct-flock64-definitions include/asm-arm/fcntl.h
--- devel/include/asm-arm/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-arm/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -6,18 +6,6 @@
 #define O_DIRECT	0200000	/* direct disk access hint - currently ignored */
 #define O_LARGEFILE	0400000
 
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-
 #include <asm-generic/fcntl.h>
 
 #endif
diff -puN include/asm-cris/fcntl.h~clean-up-struct-flock64-definitions include/asm-cris/fcntl.h
--- devel/include/asm-cris/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-cris/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -1,18 +1 @@
-#ifndef _CRIS_FCNTL_H
-#define _CRIS_FCNTL_H
-
-#define F_GETLK64      12      /*  using 'struct flock64' */
-#define F_SETLK64      13
-#define F_SETLKW64     14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-
 #include <asm-generic/fcntl.h>
-
-#endif
diff -puN include/asm-frv/fcntl.h~clean-up-struct-flock64-definitions include/asm-frv/fcntl.h
--- devel/include/asm-frv/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-frv/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -1,19 +1 @@
-#ifndef _ASM_FCNTL_H
-#define _ASM_FCNTL_H
-
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-
 #include <asm-generic/fcntl.h>
-
-#endif /* _ASM_FCNTL_H */
-
diff -puN include/asm-generic/fcntl.h~clean-up-struct-flock64-definitions include/asm-generic/fcntl.h
--- devel/include/asm-generic/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-generic/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -1,6 +1,7 @@
 #ifndef _ASM_GENERIC_FCNTL_H
 #define _ASM_GENERIC_FCNTL_H
 
+#include <linux/config.h>
 #include <linux/types.h>
 
 /* open/fcntl - O_SYNC is only implemented on blocks devices and on files
@@ -121,4 +122,28 @@ struct flock {
 };
 #endif
 
+#ifndef CONFIG_64BIT
+
+#ifndef F_GETLK64
+#define F_GETLK64	12	/*  using 'struct flock64' */
+#define F_SETLK64	13
+#define F_SETLKW64	14
+#endif
+
+#ifndef HAVE_ARCH_STRUCT_FLOCK64
+#ifndef __ARCH_FLOCK64_PAD
+#define __ARCH_FLOCK64_PAD
+#endif
+
+struct flock64 {
+	short  l_type;
+	short  l_whence;
+	loff_t l_start;
+	loff_t l_len;
+	pid_t  l_pid;
+	__ARCH_FLOCK64_PAD
+};
+#endif
+#endif /* !CONFIG_64BIT */
+
 #endif /* _ASM_GENERIC_FCNTL_H */
diff -puN include/asm-h8300/fcntl.h~clean-up-struct-flock64-definitions include/asm-h8300/fcntl.h
--- devel/include/asm-h8300/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-h8300/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -6,18 +6,6 @@
 #define O_DIRECT	0200000	/* direct disk access hint - currently ignored */
 #define O_LARGEFILE	0400000
 
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-
 #include <asm-generic/fcntl.h>
 
 #endif /* _H8300_FCNTL_H */
diff -puN include/asm-i386/fcntl.h~clean-up-struct-flock64-definitions include/asm-i386/fcntl.h
--- devel/include/asm-i386/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-i386/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -1,18 +1 @@
-#ifndef _I386_FCNTL_H
-#define _I386_FCNTL_H
-
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-
 #include <asm-generic/fcntl.h>
-
-#endif
diff -puN include/asm-m32r/fcntl.h~clean-up-struct-flock64-definitions include/asm-m32r/fcntl.h
--- devel/include/asm-m32r/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-m32r/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -1,18 +1 @@
-#ifndef _ASM_M32R_FCNTL_H
-#define _ASM_M32R_FCNTL_H
-
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-
 #include <asm-generic/fcntl.h>
-
-#endif  /* _ASM_M32R_FCNTL_H */
diff -puN include/asm-m68k/fcntl.h~clean-up-struct-flock64-definitions include/asm-m68k/fcntl.h
--- devel/include/asm-m68k/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-m68k/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -6,18 +6,6 @@
 #define O_DIRECT	0200000	/* direct disk access hint - currently ignored */
 #define O_LARGEFILE	0400000
 
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-
 #include <asm-generic/fcntl.h>
 
 #endif /* _M68K_FCNTL_H */
diff -puN include/asm-mips/fcntl.h~clean-up-struct-flock64-definitions include/asm-mips/fcntl.h
--- devel/include/asm-mips/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-mips/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -52,15 +52,6 @@ typedef struct flock {
 	long	pad[4];
 };
 
-typedef struct flock64 {
-	short	l_type;
-	short	l_whence;
-	loff_t	l_start;
-	loff_t	l_len;
-	pid_t	l_pid;
-} flock64_t;
-
-
 #define HAVE_ARCH_STRUCT_FLOCK
 
 #endif
@@ -68,5 +59,8 @@ typedef struct flock64 {
 #include <asm-generic/fcntl.h>
 
 typedef struct flock flock_t;
+#ifndef __mips64
+typedef struct flock64 flock64_t;
+#endif
 
 #endif /* _ASM_FCNTL_H */
diff -puN include/asm-parisc/fcntl.h~clean-up-struct-flock64-definitions include/asm-parisc/fcntl.h
--- devel/include/asm-parisc/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-parisc/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -33,14 +33,6 @@
 #define F_WRLCK		02
 #define F_UNLCK		03
 
-struct flock64 {
-	short l_type;
-	short l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t l_pid;
-};
-
 #include <asm-generic/fcntl.h>
 
 #endif
diff -puN include/asm-ppc/fcntl.h~clean-up-struct-flock64-definitions include/asm-ppc/fcntl.h
--- devel/include/asm-ppc/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-ppc/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -6,20 +6,6 @@
 #define O_LARGEFILE     0200000
 #define O_DIRECT	0400000	/* direct disk access hint */
 
-#ifndef __powerpc64__
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-#endif
-
 #include <asm-generic/fcntl.h>
 
 #endif /* _PPC_FCNTL_H */
diff -puN include/asm-s390/fcntl.h~clean-up-struct-flock64-definitions include/asm-s390/fcntl.h
--- devel/include/asm-s390/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-s390/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -1,27 +1 @@
-/*
- *  include/asm-s390/fcntl.h
- *
- *  S390 version
- *
- *  Derived from "include/asm-i386/fcntl.h"
- */
-#ifndef _S390_FCNTL_H
-#define _S390_FCNTL_H
-
-#ifndef __s390x__
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-#endif
-
 #include <asm-generic/fcntl.h>
-
-#endif
diff -puN include/asm-sh64/fcntl.h~clean-up-struct-flock64-definitions include/asm-sh64/fcntl.h
--- devel/include/asm-sh64/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-sh64/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -1,7 +1 @@
-#ifndef __ASM_SH64_FCNTL_H
-#define __ASM_SH64_FCNTL_H
-
 #include <asm-sh/fcntl.h>
-
-#endif /* __ASM_SH64_FCNTL_H */
-
diff -puN include/asm-sh/fcntl.h~clean-up-struct-flock64-definitions include/asm-sh/fcntl.h
--- devel/include/asm-sh/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-sh/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -1,19 +1 @@
-#ifndef __ASM_SH_FCNTL_H
-#define __ASM_SH_FCNTL_H
-
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-
 #include <asm-generic/fcntl.h>
-
-#endif /* __ASM_SH_FCNTL_H */
-
diff -puN include/asm-sparc/fcntl.h~clean-up-struct-flock64-definitions include/asm-sparc/fcntl.h
--- devel/include/asm-sparc/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-sparc/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -23,25 +23,13 @@
 #define F_SETLK		8
 #define F_SETLKW	9
 
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
 /* for posix fcntl() and lockf() */
 #define F_RDLCK		1
 #define F_WRLCK		2
 #define F_UNLCK		3
 
-struct flock64 {
-	short l_type;
-	short l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t l_pid;
-	short __unused;
-};
-
 #define __ARCH_FLOCK_PAD	short __unused;
+#define __ARCH_FLOCK64_PAD	short __unused;
 
 #include <asm-generic/fcntl.h>
 
diff -puN include/asm-v850/fcntl.h~clean-up-struct-flock64-definitions include/asm-v850/fcntl.h
--- devel/include/asm-v850/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-v850/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -6,18 +6,6 @@
 #define O_DIRECT       0200000	/* direct disk access hint - currently ignored */
 #define O_LARGEFILE    0400000
 
-#define F_GETLK64	12	/*  using 'struct flock64' */
-#define F_SETLK64	13
-#define F_SETLKW64	14
-
-struct flock64 {
-	short  l_type;
-	short  l_whence;
-	loff_t l_start;
-	loff_t l_len;
-	pid_t  l_pid;
-};
-
 #include <asm-generic/fcntl.h>
 
 #endif /* __V850_FCNTL_H__ */
diff -puN include/asm-xtensa/fcntl.h~clean-up-struct-flock64-definitions include/asm-xtensa/fcntl.h
--- devel/include/asm-xtensa/fcntl.h~clean-up-struct-flock64-definitions	2005-08-31 00:08:53.000000000 -0700
+++ devel-akpm/include/asm-xtensa/fcntl.h	2005-08-31 00:08:53.000000000 -0700
@@ -54,6 +54,7 @@ struct flock64 {
 };
 
 #define HAVE_ARCH_STRUCT_FLOCK
+#define HAVE_ARCH_STRUCT_FLOCK64
 
 #include <asm-generic/fcntl.h>
 
_
